﻿Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim path As String = Application.StartupPath

        If (path.Contains("\bin\Debug") OrElse path.Contains("\bin\Release")) Then
            For i As Integer = 0 To 2
                Dim Index As Integer = path.LastIndexOf("\"c)
                If (Index > 0) Then
                    path = path.Substring(0, Index)
                End If
            Next
        End If
        path &= "\testfile2.xls"
        Me.LoadExcelFile(path, "Tabelle1")
    End Sub

    Private Sub LoadExcelFile(path As String, table As String)
        Try
            Dim DtSet = New DataSet
            Dim connString As String

            Dim fi = New IO.FileInfo(path)
            Me.Text = fi.Name

            If path.ToLower.EndsWith(".xlsx") Then
                'connString = "Provider=Microsoft.ACE.OLEDB.12.0; Data Source=" & path & "; Extended Properties=Excel 12.0;"
                connString = "Provider=Microsoft.ACE.OLEDB.12.0; Data Source=" & path & "; Extended Properties=""Excel 12.0 Xml; HDR=YES; IMEX=1"";"
            Else
                connString = "provider=Microsoft.Jet.OLEDB.4.0; data source=" & path & "; Extended Properties=Excel 8.0;"
            End If

            Using myConnection = New OleDb.OleDbConnection(connString)
                Dim myCommand As OleDb.OleDbDataAdapter
                myCommand = New OleDb.OleDbDataAdapter("select * from [" & table & "$]", myConnection)
                myCommand.TableMappings.Add("Table", "TestTable")
                myCommand.Fill(DtSet)
                Me.DataGridView1.DataSource = DtSet.Tables(0)
                myConnection.Close()
            End Using
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Using dlg = New OpenFileDialog
            dlg.Filter = "Excel|*.xls;*.xlsx"
            If dlg.ShowDialog() <> Windows.Forms.DialogResult.OK Then
                Return
            End If
            ' Hier muss eine
            Me.LoadExcelFile(dlg.FileName, "*")
        End Using
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Me.LoadExcelFile("C:\Temp\DVD.xlsx", "Multi-DVDs")
    End Sub
End Class
